src/main/java/mi/managed/AccountController.java
/**
 * BE Java EE "Mission Impossible"
 * Mineure "développement web"
 * CentraleSupélec, campus de Rennes
 * 
 * @author Guillaume Piolle <guillaume.piolle@centralesupelec.fr>
 * 2016
 */
package mi.managed;

import mi.agents.AccountRemote;
import java.io.Serializable;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

/**
 * "Managed bean" pour gérer un compte utilisateur.
 *
 * @author Guillaume Piolle <guillaume.piolle@centralesupelec.fr>
 */
@Named("accountController")
public class AccountController implements Serializable {
    
    /**
     * Juste pour éviter un warning.
     */
    private static final long serialVersionUID = 1L;
    
    /**
     * EJB encapsulant le compte de l'utilisateur connecté.
     */
    @EJB
    private AccountRemote account;

    /**
     * Constructeur par défaut.
     */
    public AccountController() {
    }
    
    /**
     * Récupération du login de l'utilisateur actuellement connecté.
     * @return Le login de l'utilisateur.
     */
    public String getUsername() {
        return account.getUsername();
    }
    
    /**
     * Déconnexion de l'utilisateur.
     * @return "Outcome" de navigation correspondant à un rechargement de la 
     * page d'accueil, pour prendre en compte la déconnexion.
     */
    public String logout() {
        FacesContext fc = FacesContext.getCurrentInstance();
        if (fc != null) {
            ExternalContext ec = fc.getExternalContext();
            if (ec != null) {
                ec.invalidateSession(); // Lance un NPE sans conséquence : bug Glassfish, apparemment (https://java.net/jira/browse/GLASSFISH-21166)
            }
        }
        return "/index.xhtml?faces-redirect=true";
    }
    
}

src/main/java/mi/managed/MissionController.java
/**
 * BE Java EE "Mission Impossible"
 * Mineure "développement web"
 * CentraleSupélec, campus de Rennes
 * 
 * @author Guillaume Piolle <guillaume.piolle@centralesupelec.fr>
 * 2016
 */
package mi.managed;

import mi.agents.AccountRemote;
import java.io.Serializable;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.inject.Named;
import mi.missions.Mission;
import mi.missions.TraitementMissionsRemote;

/**
 * "Managed bean" pour accéder à une mission.
 * 
 * @author Guillaume Piolle <guillaume.piolle@centralesupelec.fr>
 */
@Named("missionController")
public class MissionController implements Serializable {
    //TODO Il manquera très certainement des méthodes dans cette classe.
    
    /**
     * Juste pour éviter un warning.
     */
    private static final long serialVersionUID = 1L;
    
    /**
     * La mission à laquelle il est fait référence.
     * Elle n'est pas forcément déjà connue du système.
     */
    private Mission mission;
    
    /**
     * EJB proposant l'API de traitement des missions.
     */
    @EJB
    private TraitementMissionsRemote tm;
    
    /**
     * EJB encapsulant le compte de l'utilisateur connecté.
     */
    @EJB
    private AccountRemote account;

    /**
     * Constructeur par défaut.
     */
    public MissionController() {
    }
    
    /**
     * Méthode d'initialisation.
     * On crée une nouvelle mission vierge, que l'on déclare comme ayant été
     * demandée par l'utilisateur actuellement connecté. Il est impossible de 
     * faire ça dans le constructeur, parce que les EJB sont injectés après.
     */
    @PostConstruct
    private void init() {
        this.mission = new Mission();
        if (this.account == null) {
            // Ce n'est pas forcément une erreur, qui sait.
            System.err.println("Pas moyen d'avoir un compte !");
        }
        if (this.account != null) {
            this.mission.setAgent(this.account.getUsername());
        }
    }
    
    /**
     * Récupération de l'objet mission.
     * @return L'objet mission.
     */
    public Mission getMission() {
        return this.mission;
    }
    
    /**
     * Récupération du lieu de la mission.
     * @return Le nom du lieu de la mission.
     */
    public String getLieu() {
        return this.mission.getLieu();
    }
    
    /**
     * Récupération de la date de la mission
     * @return Représentation textuelle de la date au format "dd/mm/yyyy".
     */
    public String getDate() {
        return this.mission.getDate();
    }
    
    /**
     * Définition de la date de la mission.
     * @param dateString Représentation textuelle de la date au format "dd/mm/yyyy".
     */
    public void setDate(String dateString) {
        // J'ai été sympa, je vous ai épargné cinq minutes de Google.
        try {
            DateFormat formatter = new SimpleDateFormat("dd/MM/yyyy");
            this.mission.setDate(formatter.parse(dateString));
        } catch (ParseException ex) {
            Logger.getLogger(MissionController.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    /**
     * Méthode de test de l'EJB de traitement des missions.
     * @return Résultat du test.
     */
    public String testTM() {
        return this.tm.test();
    }
    
}

src/main/java/mi/managed/MissionListController.java
/**
 * BE Java EE "Mission Impossible"
 * Mineure "développement web"
 * CentraleSupélec, campus de Rennes
 * 
 * @author Guillaume Piolle <guillaume.piolle@centralesupelec.fr>
 * 2016
 */
package mi.managed;

import java.util.ArrayList;
import javax.ejb.EJB;
import javax.inject.Named;
import mi.missions.ListeMissions;
import mi.missions.Mission;
import mi.missions.TraitementMissionsRemote;

/**
 * "Managed bean" pour accéder à la liste des missions.
 *
 * @author Guillaume Piolle <guillaume.piolle@centralesupelec.fr>
 */
@Named("missionListController")
public class MissionListController {
    //TODO Il manquera très certainement des méthodes dans cette classe.
    
    /**
     * EJB encapsulant toutes les missions connues du système.
     */
    @EJB
    private ListeMissions missions;
    
    /**
     * EJB proposant l'API de traitement des missions.
     */
    @EJB
    private TraitementMissionsRemote tm;

    /**
     * Constructeur par défaut. 
     */
    public MissionListController() {
    }
    
    /**
     * Récupération de l'ensemble des missions.
     * @return Liste de toutes les missions connues du système.
     */
    public ArrayList<Mission> getMissions() {
        return this.missions.getMissions();
    }
    
    /**
     * Introduction d'une nouvelle mission dans le système.
     * @param m La mission à introduire dans le système (elle pourra être ou ne 
     * pas être clonée).
     */
    public void creerMission(Mission m) {
        //TODO À compléter !
    }
    
}

src/main/webapp/403.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core">
    <h:head>
        <title>Mission: Impossible -- Pour une gestion moderne des déplacements professionnels</title>
        <h:outputStylesheet name="style.css"/>
    </h:head>
    <h:body>
        <f:view>
            <h1>Mission: Impossible</h1>
            <h2>Accès non autorisé</h2>
            <p>
                <ul>
                    <li><h:link outcome="/index" value="Retour à la page d'accueil" /></li>
                </ul>
            </p>
        </f:view>
    </h:body>
</html>

src/main/webapp/admin/index.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core">
    <h:head>
        <title>Mission: Impossible -- Pour une gestion moderne des déplacements professionnels</title>
        <h:outputStylesheet name="style.css"/>
    </h:head>
    <h:body>
        <f:view>
            <h1>Mission: Impossible</h1>
            <h2>Interface d'administration</h2>
            <p>
                vous êtes authentifié(e) en tant que <h:outputLabel value="#{accountController.username}" />
            </p>

            <h3>Missions connues du système</h3>
            <p><strong>À supprimer à terme&nbsp;: ne fait pas partie du cahier des charges, aucun agent ne devrait avoir accès à cette liste.</strong></p>
            <h:form id='attribution'>
                <h:dataTable value="${missionListController.missions}" var="mission">
                    <h:column>
                        <h:outputText value="${mission.id}" />
                    </h:column>
                    <h:column>
                        <h:outputText value="${mission.lieu}" />
                    </h:column>
                    <h:column>
                        <h:outputText value="${mission.date}" />
                    </h:column>
                    <h:column>
                        <h:outputText value="${mission.agent}" />
                    </h:column>
                    <h:column>
                        <h:outputText value="${mission.agentAdmin}" />
                    </h:column>
                    <h:column>
                        <h:outputText value="${mission.etat}" />
                    </h:column>
                </h:dataTable>
            </h:form>

            <h3>Missions demandées</h3>
            <p>À réaliser&nbsp;!</p>

            <h3>Les missions que vous suivez</h3>
            <p>À réaliser&nbsp;!</p>
            <h:form id="suivi">
                <h:dataTable value="..." var="mission">
                </h:dataTable>
            </h:form>

            <p> 
                <ul>
                    <li><h:link outcome="/index" value="Retour à la page d'accueil" /></li>
                </ul>
            </p>
        </f:view>
    </h:body>
</html>

src/main/webapp/agents/index.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core">
    <h:head>
        <title>Mission: Impossible -- Pour une gestion moderne des déplacements professionnels</title>
        <h:outputStylesheet name="style.css"/>
    </h:head>
    <h:body>
        <f:view>
            <h1>Mission: Impossible</h1>
            <h2>Gestion de vos missions</h2>
            <p>À réaliser&nbsp;!</p>
            <h:form id="gestion">
                <h:dataTable value="..." var="mission">
                    
                </h:dataTable>
            </h:form>

            <h2>Demande de mission</h2>
            <h:form id="creation">
                <p>À réaliser&nbsp;!</p>
            </h:form>

            <p> 
                <ul>
                    <li><h:link outcome="/index" value="Retour à la page d'accueil" /></li>
                </ul>
            </p>
        </f:view>
    </h:body>
</html>

src/main/webapp/index.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:ui="http://java.sun.com/jsf/facelets" 
      xmlns:f="http://java.sun.com/jsf/core">
    <h:head>
        <title>Mission: Impossible -- Pour une gestion moderne des déplacements professionnels</title>
        <h:outputStylesheet name="style.css"/>
    </h:head>
    <h:body>
        <f:view>
            <h1>Mission: Impossible</h1>
            <h2>Accueil de l'application</h2>
            <!-- L'attribut "rendered" permet de faire de l'affichage conditionnel de composants -->
            <ui:fragment rendered="#{accountController.username eq 'ANONYMOUS'}">
                <p>
                    Vous n'êtes pas authentifié.
                </p>
            </ui:fragment>
            <ui:fragment rendered="#{accountController.username ne 'ANONYMOUS'}">
                <p>
                    vous êtes authentifié(e) en tant que <h:outputLabel value="${accountController.username}" />
                </p>
            </ui:fragment>
            <p> 
                <ul>
                    <li><h:link outcome="admin/index" value="Accès à l'interface d'administration" /></li>
                    <li><h:link outcome="agents/index" value="Accès à l'interface de gestion de vos missions" /></li>
                    <li><h:form><h:commandLink action="#{accountController.logout()}" value="Déconnexion" /></h:form></li>
                </ul>
            </p>
        </f:view>
    </h:body>
</html>

src/main/webapp/login.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core">
    <h:head>
        <title>Mission: Impossible -- Pour une gestion moderne des déplacements professionnels</title>
        <h:outputStylesheet name="style.css"/>
    </h:head>
    <h:body>
        <f:view>
            <h1>Mission: Impossible</h1>
            <h2>Authentification</h2>
                
            <form action="j_security_check" method="POST">
                Identifiant&nbsp;: <input type="text" name="j_username" />
                <br />
                Mot de passe&nbsp;: <input type="password" name="j_password" />
                <br />
                <input type="submit" value="Connexion" />
            </form>
            <p> 
                <ul>
                    <li><h:link outcome="/index" value="Retour à la page d'accueil" /></li>
                </ul>
            </p>
        </f:view>
    </h:body>
</html>

src/main/webapp/login_error.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core">
    <h:head>
        <title>Mission: Impossible -- Pour une gestion moderne des déplacements professionnels</title>
        <h:outputStylesheet name="style.css"/>
    </h:head>
    <h:body>
        <f:view>
            <h1>Mission: Impossible</h1>
            <h2>Erreur d'authentification</h2>
            <p>
                <ul>
                    <li><h:link outcome="/index" value="Retour à la page d'accueil" /></li>
                </ul>
            </p>
        </f:view>
    </h:body>
</html>